## Contributing to Sol

Looking to contribute to Sol? Well, first thing I want to mention is thank you!
Second of all, this is probably where you should look :)

## Reporting Issues

If you found a bug, please make sure to make an issue in the issue tracker.

The guidelines for reporting a bug are relatively simple and are as follows:

1. Produce a simple, short, compilable test case that reproduces your problem.
2. Make a descriptive title that summarises the bug as a whole.
3. Explain the bug in as much detail as you can in the body of the issue.

If you have all of those requirements set, then your issue reporting is golden.

## Submitting a pull request

Submitting a pull request is fairly simple, just make sure it focuses on a single aspect and doesn't 
manage to have scope creep and it's probably good to go. It would be incredibly lovely if the style is 
consistent to those found in the repository.

To help with this, a `.clang-format` is included. Please run it on your code before you push anything.

If you don't meet all of these style guidelines, don't fret. I'll probably fix it. But please
do make an effort to actually meet them. Otherwise I'm more likely to reject the pull request.
